program cross

  use dcl
  use dcl_defval
  use dcl_arrayval
  use dcl_read_name
  use dcl_alloc
  use basis
  use Derivation
  use vert_coord_conv
  use max_min
  use file_operate
  use Dcl_Automatic
  use typhoon_analy
  use math_const
  use Thermo_Const
  use Thermo_Function

  implicit none

!  2d = 1->pressure
!  3d = 1,2,3->u,v,w
!  Ϸ
!  2d = 1,2 -> ps,pts, 3d = 1,2 -> u,v 3 -> z*
!  nnx(1) = 1 Ǹ, nnx(2) = ΰǱ
!  grdname  terrain ǡƤ,
!  Ϸθ, ʻҤϷޤäƤ undef ʿʤ.
!  ޤ, ad3val  terrain following ɸäƤȤ,
!  ̤ȤʻҤ޽Ԥ. ΤȤޤ
!  Ϸθ뤬, ϱľΤ.
!  grdname ꤵƤȤ, ɽ̵.

  integer :: i, j, k, stat, minnx,minny, id, it
  real :: min_val
  real, parameter :: undef=-999.0
  real, allocatable :: theta(:), r(:)  ! tangential mean 
  real, allocatable :: zd(:), xd(:)  ! 
  real, allocatable, dimension(:,:) :: ps, terrain, tmp2d, tmp2ds
  real, allocatable, dimension(:,:,:) :: tmp3d, zflat
  real, allocatable, dimension(:,:,:) :: u, v, w
  character(80) :: input_fname, output_fname
  character(8) :: tname
  character(3) :: hour
  character(2) :: minute

  call dcl_read_nml( stat )
  call dcl_alloc_val( stat )
  call dcl_pointdef( stat )

!-- ϥե (¸) 뤿̿ ---
      CALL SWpSET( 'LDUMP', ldump )
      CALL SWpSET( 'LWAIT', lwait )
      CALL SWpSET( 'LWAIT1', lwait1 )

!-- dcl Ƽ
!-- ʰ̥ե ---
  call SGISET('IFONT', 2)
  call UZFACT(0.65)
  call DclSetParm( 'ENABLE_CONTOUR_MESSAGE', .false. )
  call GLRSET( 'RMISS', undef )
  write(*,*) "main undef", undef
  call GLLSET( 'LMISS', .true. )

  call color_setting( shade_num, (/cmin, cmax/),  &
  &                   min_tab=13999, max_tab=89999,  &
  &                   col_tab=14 )

  allocate(zd(nnz(1):nnz(2)))
  allocate(theta(ny))
  allocate(r(nnx(1):nnx(2)))
  allocate(xd(nnx(1):nnx(2)))
  allocate(tmp3d(nx,ny,nz))
  allocate(zflat(nx,ny,nz))
  allocate(u(nx,ny,nz))
  allocate(v(nx,ny,nz))
  allocate(w(nx,ny,nz))
  allocate(ps(nx,ny))
  allocate(terrain(nx,ny))
  allocate(tmp2d(nnx(1):nnx(2),nnz(1):nnz(2)))
  allocate(tmp2ds(nnx(1):nnx(2),nnz(1):nnz(2)))

  w=0.0  ! ߡѿ

!-- γٳʻҤη ---
  do j=1,ny
     theta(j)=2.0*pi*(real(j-1)/real(ny))
  end do

!-- ΰؤͤ

  do j=nnx(1), nnx(2)
     xd(j)=x(j)*1.e-3
     r(j)=x(j)
  end do

  do j=nnz(1), nnz(2)
     zd(j)=z(j)*1.e-3
  end do

!-- ̴αľɸ
  do k=1,nz
     zflat(:,:,k)=z(k)
  end do

!  x=x*1.0e-3
!  y=y*1.0e-3
!  z=z*1.0e-3

  call DclOpenGraphics(IWS)

  do i=ininame,ininame+(fnumber-1)*dt,dt
     it=real(i/dt)+1
     write(tname,'(i8.8)') i
     input_fname=trim(hname)//tname//trim(footname)    ! ʸĹΤޤζ, trim 
write(*,*) input_fname

     call read_file( 'test.binbin', 200, 40, 1, tmp2d(1:200,1:40) )
     call read_file( 'test.binbin', 200, 40, 2, tmp2ds(1:200,1:40) )

     do k=1,40
        do j=1,200
           if(abs(tmp2d(j,k))>1.0e4)then
              tmp2d(j,k)=0.0
           end if
           if(abs(tmp2ds(j,k))>1.0e4)then
              tmp2ds(j,k)=0.0
           end if
        end do
     end do

!     output_fname='dmp.'//tname
     write(tname,'(i8.8)') i

     hour=i2c_convert( i/3600, '(i3.3)' )
     minute=i2c_convert( mod(i,3600)/60, '(i2.2)' )
     output_fname=trim(title_name)//' _('//hour(1:3)//':'//minute(1:2)//')"'

     call Dcl_2D_cont_shade( trim(output_fname),  &
   &      xd(nnx(1):nnx(2)), zd(nnz(1):nnz(2)),  &
   &      tmp2d(nnx(1):nnx(2),nnz(1):nnz(2)),  &
   &      tmp2ds(nnx(1):nnx(2),nnz(1):nnz(2)),  &
   &      (/contmin, contmax/), (/cmin, cmax/),  &
   &      (/'horizon (km)', 'altitude (km)'/),  &
   &      (/form_typec, form_types/), (/0.1, 0.95/),  &
   &      (/0.6, 0.9/), c_num=(/10, shade_num/),  &
   &      no_tone=.true. )

     call STSSET( 4 )
     call STASET( 10.0 )
     call STTSET( 1 )
     call STRLIN( xd(nnx(1):nnx(2)), zd(nnz(1):nnz(2)),  &
  &               tmp2d(nnx(1):nnx(2),nnz(1):nnz(2)),  &
  &               tmp2ds(nnx(1):nnx(2),nnz(1):nnz(2)),  &
  &               nnx(2)-nnx(1)+1, nnz(2)-nnz(1)+1 )

!     open(unit=10,file='test.binbin',access='direct',  &
!  &       recl=4*(nnx(2)-nnx(1)+1)*(nnz(2)-nnz(1)+1),status='unknown')

!     write(10,rec=1) ((tmp2d(id,j),id=nnx(1),nnx(2)),j=nnz(1),nnz(2))
!     write(10,rec=2) ((tmp2ds(id,j),id=nnx(1),nnx(2)),j=nnz(1),nnz(2))
!     close(unit=10)

     call tone_bar( shade_num, (/cmin, cmax/), (/0.1,0.9/),  &
  &                 (/0.5,0.525/), trim(form_types),  col_mem_num=10,  &
  &                 dir='y', trigle='a', title='m/s', titles='b', titlep=0.0 )

write(*,*) "debuggg"


  end do

write(*,*) "kokodetomaru"
  call DclCloseGraphics
write(*,*) "kokodetomaru"

  deallocate(r)
  deallocate(xd)
  deallocate(zd)
  deallocate(theta)

end program
